#!/usr/bin/perl

require '/usr/bin/byteutil.pl';

#converts lexmark prn files back to bitmaps
if (@ARGV < 1 || @ARGV > 2) {print "Usage: $0 <lm1100 file> [output file base]\n"; exit 1;}

open(FILE,$ARGV[0])||die "Couldn't open ".$ARGV[0];

$file_base = $ARGV[1];

#read in the entire file
$bytes = "";
while(read(FILE, $bytes, 255, length $bytes) == 255) {}

#skip the paper readying
$bytes = substr $bytes, 112;

$min_x = 99999999;
$min_y = 99999999;
$max_x = -9999999;
$max_y = -9999999;
$RED_JET_X1 = -18;
$RED_JET_Y1 = 20;
$RED_JET_X2 = -9;
$RED_JET_Y2 = 20;
$BLUE_JET_X1 = 1;
$BLUE_JET_Y1 = 40;
$BLUE_JET_X2 = 8;
$BLUE_JET_Y2 = 40;
$GREEN_JET_X1 = 0;
$GREEN_JET_Y1 = 0;
$GREEN_JET_X2 = 9;
$GREEN_JET_Y2 = 0;
$PAPER_ADVANCE = 10;
$file_no = 1;

$first_color = 1;

while(1)
{
    if($bytes =~ /^\x22\x80.{6}/s)
    {
        #read in the paper advance
	print "paper advance ";
	print &printBytes($&, 30, 0, length $&);
	$bytes = $';
    }
    elsif($bytes =~ /^\x23\x80(.)(.).{4}/s)
    {
	$paper_advance = ((ord $1) * 256 + (ord $2)) *10 /20;
        #read in the paper advance
	print "paper advance amount: ".$paper_advance." bytes :";
	print &printBytes($&, 30, 0, length $&);
	$head_y += int ($paper_advance);
	$bytes = $';
    }
    elsif($bytes =~ /^\x33\x00{7}/s)
    {
        #read in not sure command
	print "read not sure ";
	print &printBytes($&, 30, 0, length $&);
	$bytes = $';
    }
    elsif($bytes =~ /^\x31\x18.{6}/s)
    {
        #read in not sure command
	print "read not sure ";
	print &printBytes($&, 30, 0, length $&);
	$bytes = $';
    }
    elsif($bytes =~ /^\x40(\x84|\xc4|\x24)(.)(.)(.)(.)(.)(.)\x41(.)(.)(.)\x00\x00\x00\x00\x80\x00\x00(.)(.)\x00\x00\x00/s)
    {
        #read in color command
	print "read color command, ";
	print &printBytes($&, 30, 0, length $&);

	$colorflag = ord $1; #don't know the difference between 84 and c4

	$pkts = nbr($2,$3);
	$pkts2 = nbr($4,$5);
	$start = nbr($6,$7);
	$unk = ord $8;
	$reverse = nbr($9,$10);
	$byte_length = nbr($11,$12);

	$line_start = $start / 2;

	if($colorflag == 0x24)
	{
	    #b&w
	    print STDERR "Error: pkts($pkts) must equal bytes($byte_length) / 7\n" if ($pkts != $byte_length / 7);
	    print STDERR "Error: first time only! pkt2($pkts2) must equal bytes($byte_length)/14 + start($start)/4 - 373.5\n" 
		if ($first_color && $pkts2 != $byte_length/14 + $start/4 - 373.5);
	    
	    print STDERR "Error: past first time, pkt2($pkts2) must equal (pkts($pkts)/2 + 174\n" 
		if (!$first_color && $pkts2 != ($pkts / 2 + 174));
	    
	    print STDERR "Error: 41xx must be 41 10, got 41 $last_unk\n" if (!$first_color && $last_unk != 16);
	    
	    print STDERR "Error: last_reverse($last_reverse) != ".
		"(last_pkts($last_pkts) * 2 + last_start($last_start) - start($start)) / 4 + 50 == ".
		    (($last_pkts * 2 + $last_start - $start) / 4 + 50)."\n"
			if (!$first_color && ($last_pkts * 2 + $last_start - $start) / 4 + 50 != $last_reverse);
	}
	else {
	    #color

	    #check rules
	    print STDERR "Error: pkts($pkts) must equal bytes($byte_length) / 6\n" if ($pkts != $byte_length / 6);
	    print STDERR "Error: first time only! pkt2($pkts2) must equal bytes($byte_length)/12 + start($start)/4 - 373.5\n" 
		if ($first_color && $pkts2 != $byte_length/12 + $start/4 - 373.5);
	    
	    print STDERR "Error: past first time, pkt2($pkts2) must equal (bytes($byte_length) + 2184)/12\n" 
		if (!$first_color && $pkts2 != ($byte_length + 2184)/12);
	    
	    print STDERR "Error: 41xx must be 41 10, got 41 $last_unk\n" if (!$first_color && $last_unk != 16);
	    
	    print STDERR "Error: last_reverse($last_reverse) != ".
		"(last_pkts($last_pkts) * 2 + last_start($last_start) - start($start)) / 4 + 58 == ".
		    (($last_pkts * 2 + $last_start - $start) / 4 + 58)."\n"
			if (!$first_color && ($last_pkts * 2 + $last_start - $start) / 4 + 58 != $last_reverse);
	}

	$last_unk = $unk;
	$last_pkts = $pkts;
	$last_reverse = $reverse;
	$last_start = $start;

	$draw = substr $',0,$byte_length;
	$bytes = substr $',$byte_length;

	#read bytes
	$file = $file_base.$file_no.".ppm";
	    
	print "pkts: $pkts, pkts2: $pkts2, start: $start, unk: $unk, reverse: $reverse, byte_length: $byte_length file: ".$file."\n";
	
	$x = $line_start;

	#convert these to paper
	if($colorflag == 0x24) #bw
	{
	    while((length $draw) >= 7)
	    {
		my @pkt = split(//,substr $draw, 0, 7);
		$draw = substr($draw,7);
		my $byte_index;
		my $bit_index;
		
		for($byte_index = 0; $byte_index < 7; $byte_index ++)
		{
		    for($bit_index = 7; $bit_index >= 0; $bit_index --)
		    {
			$mask = 1 << $bit_index;
			$b = (ord($pkt[$byte_index]) & $mask) != 0 ? 127 : 0;

			if($bit_index %2 == 0)
			{
			    $xoff = 9;
			}
			else
			{
			    $xoff = 0;
			}

			$y = $head_y + ($byte_index) * 8 + (7-$bit_index);
			
			$b += $red_paper{$x+$xoff,$y};
			drawdot( $b,$b,$b,$x + $xoff,$y);
		    }
		}

		$x++;
	    }
	}
	else {
	    while((length $draw) >= 6)
	    {
		$x++;
		$g = (ord (substr $draw, 0,1)) * 256 + ord (substr $draw, 1,1);
		$r = (ord (substr $draw, 2,1)) * 256 + ord (substr $draw, 3,1);
		$b = (ord (substr $draw, 4,1)) * 256 + ord (substr $draw, 5,1);
		
		$draw = substr($draw,6);
		
		#highest bit is topmost.
		if($file_base)
		{
		    for($bit_index = 15; $bit_index >= 0; $bit_index--)
		    {
			$mask = 1 << $bit_index;
			$rb = $r & $mask;
			$gb = $g & $mask;
			$bb = $b & $mask;
			
			$y = $head_y + -int ($bit_index);
			
			if($bit_index % 2 == 0)
			{
			    $rjx = $RED_JET_X2;
			    $rjy = $RED_JET_Y2;
			    $gjx = $GREEN_JET_X2;
			    $gjy = $GREEN_JET_Y2;
			    $bjx = $BLUE_JET_X2;
			    $bjy = $BLUE_JET_Y2;
			}
			else
			{
			    $rjx = $RED_JET_X1;
			    $rjy = $RED_JET_Y1;
			    $gjx = $GREEN_JET_X1;
			    $gjy = $GREEN_JET_Y1;
			    $bjx = $BLUE_JET_X1;
			    $bjy = $BLUE_JET_Y1;
			}
			
			drawdot($rb != 0 ? 255 : 128,0,0,$x+$rjx,$y+$rjy);
			drawdot(0,$gb != 0 ? 255 : 128,0,$x+$gjx,$y+$gjy);
			drawdot(0,0,$bb != 0 ? 255 : 128,$x+$bjx,$y+$bjy);
		    }
		}
	    }
	}
	$zzzz = $zzzz ? 0 : 1;
	print "min($min_x,$min_y) max($max_x,$max_y)\n";
	if($file_base)
	{
	    make_ppm($file);
	}
	$file_no++;

	$first_color = 0;
    }
    else {

	if((length $bytes) != 0) {
	    print STDERR "Error: done with ".(length $bytes). " unknown bytes\n";
	}

	last;
    }

}

print STDERR "Error: Last 41 xx must be 41 00\n" if $last_unk != 0;

#print out bytes

sub make_ppm
{
    my ($file) = @_;
    
    open(FILE, ">$file") || die "Couldn't open $file for writing";


    print FILE "P3\n";
    print FILE "# from lexmark2ppm.pl\n";
    print FILE "".($max_x-$min_x+1)." ".($max_y-$min_y+1)."\n";
    print FILE "255\n";
    
    for($y = $min_y; $y <= $max_y; $y ++)
    {
	for($x = $min_x; $x <= $max_x; $x ++)
	{
	    $r = $red_paper{$x,$y} || 0;
	    $g = $green_paper{$x,$y} || 0;
	    $b = $blue_paper{$x,$y} || 0;

	    print FILE "$r $g $b  ";

#	    print FILE "$r 0 0  ";
	}
	print FILE "\n";
    }
    
    close FILE;
}



sub drawdot
{
    my ($r,$g,$b,$x,$y) = @_;

    if($x < $min_x)
    {
	$min_x = $x;
    }
    if($x > $max_x)
    {
	$max_x = $x;
    }
    if($y < $min_y)
    {
	$min_y = $y;
    }
    if($y > $max_y)
    {
	$max_y = $y;
    }

    $red_paper{$x,$y} = $r if ($r);
    $green_paper{$x,$y} = $g if ($g);
    $blue_paper{$x,$y} = $b if ($b);
}

sub nbr
{
    my ($b1,$b2) = @_;

    return ((ord $b1) << 8) + ord $b2;
}
